#include <stdint.h>
#include "flash_2_hw.h"

sbit FLASH_2_WP 	at PORTD4_bit;
sbit FLASH_2_WP_DIR 	at DDD4_bit;
sbit FLASH_2_CS 	at PORTA5_bit;
sbit FLASH_2_CS_DIR 	at DDA5_bit;
sbit FLASH_2_HLD 	at PORTA6_bit;
sbit FLASH_2_HLD_DIR 	at DDA6_bit;

int main(void)
{
    
    uint8_t buffer[4]                   = {15,20,25,30};
    uint32_t count                      = 4;
    uint32_t address                    = 0x0100F0;
    uint8_t receive_buffer[4];
    char tmp[20];

    FLASH_2_WP_DIR  = 1;
    FLASH_2_CS_DIR  = 1;
    FLASH_2_HLD_DIR = 1;


    SPI1_Init_Advanced( _SPI_MASTER, _SPI_FCY_DIV32, _SPI_CLK_LO_LEADING );
    Delay_ms(300);

    UART1_Init(9600);
    Delay_ms(300);

    UART1_Write_Text( "Initializing Flash 2 click... " );
    UART1_Write_Text( "\r\n" );
    flash_2_init();
    Delay_ms(300);
    flash_2_global_block_unlock();
    Delay_ms(400);
    flash_2_chip_erase();
    Delay_ms(300);
    flash_2_write( address, buffer, count );
    flash_2_read( address, receive_buffer, count );

    UART1_Write_Text( "Initial Values: " );
    while( count-- )
    {
       ByteToStr( buffer[count], tmp );
       UART1_Write_Text( tmp );
    }
    UART1_Write_Text( "\r\n" );
    count = 4;

    UART1_Write_Text( "Received Values: " );
    while( count -- )
    {
       ByteToStr( receive_buffer[count], tmp );
       UART1_Write_Text( tmp );
    }
    UART1_Write_Text( "\r\n" );

    return;
}